package aisl.model;

import java.io.Serializable;
import java.util.Objects;

/**
 *
 * @author rosmord
 */
public class User implements Serializable {

    private String login;
    private String password;
    private Group group = Group.USER;

    User(String login, String motDePasse) {
        this(login, motDePasse, Group.USER);
    }

    User(String login, String motDePasse, Group groupe) {
        if (login == null || motDePasse == null || groupe == null) {
            throw new IllegalArgumentException("No null values");
        }
        if ("".equals(login)) {
            throw new IllegalArgumentException("Login can't be empty");
        }

        this.login = login;
        this.password = motDePasse;
        this.group = groupe;
    }

    public String getLogin() {
        return login;
    }

    public String getPassword() {
        return password;
    }

    public Group getGroup() {
        return group;
    }

    void setPassword(String password) {
        this.password = password;
    }

    void setGroup(Group group) {
        this.group = group;
    }
    
    @Override
    public int hashCode() {
        int hash = 7;
        hash = 41 * hash + Objects.hashCode(this.login);
        return hash;
    }

    @Override
    public boolean equals(Object obj) {
        if (obj == null) {
            return false;
        }
        if (getClass() != obj.getClass()) {
            return false;
        }
        final User other = (User) obj;
        return Objects.equals(this.login, other.login);
    }

    

    @Override
    public String toString() {
        return login;
    }
    
    
}
