package aisl.ui;

import java.io.IOException;
import java.io.UnsupportedEncodingException;
import javax.servlet.ServletException;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 * Servlet / front controller
 *
 * @author rosmord
 */
@WebServlet(name = "Do", urlPatterns = {"/do"})
public class Do extends HttpServlet {

    @Override
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        ControlCommand controlCommand = prepareCommand(request, response);

        DisplayInfo display = controlCommand.doCommandGET();
        // display result.
        display.display(this, request, response);
    }

    @Override
    protected void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
        ControlCommand controlCommand = prepareCommand(request, response);

        DisplayInfo display = controlCommand.doCommandPOST();
        // display result.
        display.display(this, request, response);
    }

    private ControlCommand prepareCommand(HttpServletRequest request, HttpServletResponse response) throws UnsupportedEncodingException {
        // Ensures entries are in utf-8.
        request.setCharacterEncoding("utf-8");
        String command = request.getParameter("command");
        // Default Command: 
        // We suggest printing a nicer message... it's the default welcome page, after all.       
        ControlCommand controlCommand = new MessageCommand("Unknown command " + command, getServletContext(), request, response);
        if ("list".equals(command)) {
            controlCommand = new MessageCommand("Write the 'list' command...", getServletContext(), request, response);
        } else if ("login".equals(command)) {
            controlCommand = new LoginCommand(getServletContext(), request, response);
        }
        // And so on...
        return controlCommand;
    }
}
