/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package aisl.ui;

import aisl.model.*;
import javax.servlet.ServletContext;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

/**
 * Login command. Checks login and password for the user.
 * 
 * If the "nextPage" bean is defined, it will be used as next page name.
 * Else, the welcome page is used.
 *
 * @author rosmord
 */
public class LoginCommand extends ControlCommand {

    public LoginCommand(ServletContext servletContext, HttpServletRequest request, HttpServletResponse response) {
        super(servletContext, request, response);
    }

    @Override
    public DisplayInfo doCommandGET() {
        return DisplayInfo.buildJsp("login.jsp");
    }

    @Override
    public DisplayInfo doCommandPOST() {
        String pageSuivante = request.getParameter("nextPage");
        String login = request.getParameter("login");
        String motDePasse = request.getParameter("password");
        ForumFacade f = ForumFacade.getInstance();
        User u = f.getUser(login);
        if (u != null && u.getPassword().equals(motDePasse)) {
            HttpSession session = request.getSession();
            session.setAttribute("user", u);
            if (pageSuivante == null || "".equals(pageSuivante)) {
                pageSuivante = "do?command=list";
            }
            return DisplayInfo.buildRedirection(pageSuivante);
        } else {
            request.setAttribute("message", "Bad login or password");
            return DisplayInfo.buildJsp("login.jsp");
        }

    }
}
